﻿using System;
using System.Drawing;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace WindowsFormsApplication16
{
    public partial class Form1 : Form
    {
        private static readonly ToolTip toolTip = new ToolTip();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            winformsMap1.MapUnit = GeographyUnit.DecimalDegree;

            Feature point1 = new Feature(new PointShape(1.2, 1.3));
            Feature point2 = new Feature(new PointShape(1.15, 1.2));
            Feature point3 = new Feature(new PointShape(1.4, 2.1));
            Feature point4 = new Feature(new PointShape(2.2, 1.3));
            Feature point5 = new Feature(new PointShape(0.2, 2.3));

            InMemoryFeatureLayer pointsLayer = new InMemoryFeatureLayer();

            pointsLayer.InternalFeatures.Add(point1);
            pointsLayer.InternalFeatures.Add(point2);
            pointsLayer.InternalFeatures.Add(point3);
            pointsLayer.InternalFeatures.Add(point4);
            pointsLayer.InternalFeatures.Add(point5);

            pointsLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = new ClusterPointStyle(PointSymbolType.Diamond, new GeoSolidBrush(GeoColor.SimpleColors.Copper), 10);
            pointsLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

            LayerOverlay overlay = new LayerOverlay();
            overlay.Layers.Add(pointsLayer);

            pointsLayer.Open();
            RectangleShape boxing = pointsLayer.GetBoundingBox();
            pointsLayer.Close();

            winformsMap1.Overlays.Add("PointOverlay", overlay);
            winformsMap1.CurrentExtent = new RectangleShape(0, 2.5, 2.5, 0);
            winformsMap1.Refresh();
        }

        private void winformsMap1_MouseMove(object sender, MouseEventArgs e)
        {
            ((LayerOverlay)winformsMap1.Overlays["PointOverlay"]).Layers[0].Open();
            RectangleShape boxing = ((LayerOverlay)winformsMap1.Overlays["PointOverlay"]).Layers[0].GetBoundingBox();
            ((LayerOverlay)winformsMap1.Overlays["PointOverlay"]).Layers[0].Close();

            RectangleShape rect = winformsMap1.CurrentExtent;
            PointShape mousePoint = ExtentHelper.ToWorldCoordinate(rect, new ScreenPointF(e.X, e.Y), winformsMap1.Width, winformsMap1.Height);

            if (boxing.Contains(mousePoint))
            {
                toolTip.ToolTipTitle = "There are five points on Point Overlay.";
                toolTip.Show("There are five points on Point Overlay.", this, new Point(
                    (int)(ExtentHelper.ToScreenCoordinate(rect, new Feature(boxing.GetCenterPoint()), winformsMap1.Width, winformsMap1.Height).X),
                    (int)(ExtentHelper.ToScreenCoordinate(rect, new Feature(boxing.GetCenterPoint()), winformsMap1.Width, winformsMap1.Height).Y)));
            }
            else
            {
                toolTip.Hide(this);
            }
            winformsMap1.Refresh();
        }
    }
}
